package com.rebusland.fin.derivatives.eq.server.input.model;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;
import org.joda.beans.gen.PropertyDefinition;

import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;
import java.util.Map;
import java.util.NoSuchElementException;
import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class Derivative extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition(validate = "notNull")
	private final Underlying underlying;

	@PropertyDefinition(validate = "notNull")
	private final Long issueDate;

	@PropertyDefinition(validate = "notNull")
	private final Long expiryDate;

	@PropertyDefinition(validate = "notEmpty")
	private final String payoffId;

	// TODO temporary: this is ugly!!!
	// Must review the Derivative/Payoff hierarchy: it's probably better to embed the Derivative fields (underlying, issue, maturity)
	// into the <Payoff> (e.g. AsianOption, VanillaOption) bean by composition.
	@PropertyDefinition
	private final AsianOption asianOption;

	@PropertyDefinition
	private final VanillaOption vanillaOption;

	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code Derivative}.
	 * @return the meta-bean, not null
	 */
	public static Derivative.Meta meta() {
		return Derivative.Meta.INSTANCE;
	}

	static {
		MetaBean.register(Derivative.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static Derivative.Builder builder() {
		return new Derivative.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected Derivative(Derivative.Builder builder) {
		JodaBeanUtils.notNull(builder.underlying, "underlying");
		JodaBeanUtils.notNull(builder.issueDate, "issueDate");
		JodaBeanUtils.notNull(builder.expiryDate, "expiryDate");
		JodaBeanUtils.notEmpty(builder.payoffId, "payoffId");
		this.underlying = builder.underlying;
		this.issueDate = builder.issueDate;
		this.expiryDate = builder.expiryDate;
		this.payoffId = builder.payoffId;
		this.asianOption = builder.asianOption;
		this.vanillaOption = builder.vanillaOption;
	}

	@Override
	public Derivative.Meta metaBean() {
		return Derivative.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the underlying.
	 * @return the value of the property, not null
	 */
	public Underlying getUnderlying() {
		return underlying;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the issueDate.
	 * @return the value of the property, not null
	 */
	public Long getIssueDate() {
		return issueDate;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the expiryDate.
	 * @return the value of the property, not null
	 */
	public Long getExpiryDate() {
		return expiryDate;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the payoffId.
	 * @return the value of the property, not empty
	 */
	public String getPayoffId() {
		return payoffId;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the asianOption.
	 * @return the value of the property
	 */
	public AsianOption getAsianOption() {
		return asianOption;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the vanillaOption.
	 * @return the value of the property
	 */
	public VanillaOption getVanillaOption() {
		return vanillaOption;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			Derivative other = (Derivative) obj;
			return JodaBeanUtils.equal(underlying, other.underlying) &&
					JodaBeanUtils.equal(issueDate, other.issueDate) &&
					JodaBeanUtils.equal(expiryDate, other.expiryDate) &&
					JodaBeanUtils.equal(payoffId, other.payoffId) &&
					JodaBeanUtils.equal(asianOption, other.asianOption) &&
					JodaBeanUtils.equal(vanillaOption, other.vanillaOption);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(underlying);
		hash = hash * 31 + JodaBeanUtils.hashCode(issueDate);
		hash = hash * 31 + JodaBeanUtils.hashCode(expiryDate);
		hash = hash * 31 + JodaBeanUtils.hashCode(payoffId);
		hash = hash * 31 + JodaBeanUtils.hashCode(asianOption);
		hash = hash * 31 + JodaBeanUtils.hashCode(vanillaOption);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(224);
		buf.append("Derivative{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("underlying").append('=').append(JodaBeanUtils.toString(underlying)).append(',').append(' ');
		buf.append("issueDate").append('=').append(JodaBeanUtils.toString(issueDate)).append(',').append(' ');
		buf.append("expiryDate").append('=').append(JodaBeanUtils.toString(expiryDate)).append(',').append(' ');
		buf.append("payoffId").append('=').append(JodaBeanUtils.toString(payoffId)).append(',').append(' ');
		buf.append("asianOption").append('=').append(JodaBeanUtils.toString(asianOption)).append(',').append(' ');
		buf.append("vanillaOption").append('=').append(JodaBeanUtils.toString(vanillaOption)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code Derivative}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code underlying} property.
		 */
		private final MetaProperty<Underlying> underlying = DirectMetaProperty.ofImmutable(
				this, "underlying", Derivative.class, Underlying.class);
		/**
		 * The meta-property for the {@code issueDate} property.
		 */
		private final MetaProperty<Long> issueDate = DirectMetaProperty.ofImmutable(
				this, "issueDate", Derivative.class, Long.class);
		/**
		 * The meta-property for the {@code expiryDate} property.
		 */
		private final MetaProperty<Long> expiryDate = DirectMetaProperty.ofImmutable(
				this, "expiryDate", Derivative.class, Long.class);
		/**
		 * The meta-property for the {@code payoffId} property.
		 */
		private final MetaProperty<String> payoffId = DirectMetaProperty.ofImmutable(
				this, "payoffId", Derivative.class, String.class);
		/**
		 * The meta-property for the {@code asianOption} property.
		 */
		private final MetaProperty<AsianOption> asianOption = DirectMetaProperty.ofImmutable(
				this, "asianOption", Derivative.class, AsianOption.class);
		/**
		 * The meta-property for the {@code vanillaOption} property.
		 */
		private final MetaProperty<VanillaOption> vanillaOption = DirectMetaProperty.ofImmutable(
				this, "vanillaOption", Derivative.class, VanillaOption.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"underlying",
				"issueDate",
				"expiryDate",
				"payoffId",
				"asianOption",
				"vanillaOption");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case -1770633379:  // underlying
					return underlying;
				case 184285223:  // issueDate
					return issueDate;
				case -816738431:  // expiryDate
					return expiryDate;
				case 1384550210:  // payoffId
					return payoffId;
				case -1675231623:  // asianOption
					return asianOption;
				case -10319920:  // vanillaOption
					return vanillaOption;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public Derivative.Builder builder() {
			return new Derivative.Builder();
		}

		@Override
		public Class<? extends Derivative> beanType() {
			return Derivative.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code underlying} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Underlying> underlying() {
			return underlying;
		}

		/**
		 * The meta-property for the {@code issueDate} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Long> issueDate() {
			return issueDate;
		}

		/**
		 * The meta-property for the {@code expiryDate} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<Long> expiryDate() {
			return expiryDate;
		}

		/**
		 * The meta-property for the {@code payoffId} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<String> payoffId() {
			return payoffId;
		}

		/**
		 * The meta-property for the {@code asianOption} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<AsianOption> asianOption() {
			return asianOption;
		}

		/**
		 * The meta-property for the {@code vanillaOption} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<VanillaOption> vanillaOption() {
			return vanillaOption;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case -1770633379:  // underlying
					return ((Derivative) bean).getUnderlying();
				case 184285223:  // issueDate
					return ((Derivative) bean).getIssueDate();
				case -816738431:  // expiryDate
					return ((Derivative) bean).getExpiryDate();
				case 1384550210:  // payoffId
					return ((Derivative) bean).getPayoffId();
				case -1675231623:  // asianOption
					return ((Derivative) bean).getAsianOption();
				case -10319920:  // vanillaOption
					return ((Derivative) bean).getVanillaOption();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code Derivative}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<Derivative> {

		private Underlying underlying;
		private Long issueDate;
		private Long expiryDate;
		private String payoffId;
		private AsianOption asianOption;
		private VanillaOption vanillaOption;

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(Derivative beanToCopy) {
			this.underlying = beanToCopy.getUnderlying();
			this.issueDate = beanToCopy.getIssueDate();
			this.expiryDate = beanToCopy.getExpiryDate();
			this.payoffId = beanToCopy.getPayoffId();
			this.asianOption = beanToCopy.getAsianOption();
			this.vanillaOption = beanToCopy.getVanillaOption();
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case -1770633379:  // underlying
					return underlying;
				case 184285223:  // issueDate
					return issueDate;
				case -816738431:  // expiryDate
					return expiryDate;
				case 1384550210:  // payoffId
					return payoffId;
				case -1675231623:  // asianOption
					return asianOption;
				case -10319920:  // vanillaOption
					return vanillaOption;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case -1770633379:  // underlying
					this.underlying = (Underlying) newValue;
					break;
				case 184285223:  // issueDate
					this.issueDate = (Long) newValue;
					break;
				case -816738431:  // expiryDate
					this.expiryDate = (Long) newValue;
					break;
				case 1384550210:  // payoffId
					this.payoffId = (String) newValue;
					break;
				case -1675231623:  // asianOption
					this.asianOption = (AsianOption) newValue;
					break;
				case -10319920:  // vanillaOption
					this.vanillaOption = (VanillaOption) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public Derivative build() {
			return new Derivative(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the underlying.
		 * @param underlying  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder underlying(Underlying underlying) {
			JodaBeanUtils.notNull(underlying, "underlying");
			this.underlying = underlying;
			return this;
		}

		/**
		 * Sets the issueDate.
		 * @param issueDate  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder issueDate(Long issueDate) {
			JodaBeanUtils.notNull(issueDate, "issueDate");
			this.issueDate = issueDate;
			return this;
		}

		/**
		 * Sets the expiryDate.
		 * @param expiryDate  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder expiryDate(Long expiryDate) {
			JodaBeanUtils.notNull(expiryDate, "expiryDate");
			this.expiryDate = expiryDate;
			return this;
		}

		/**
		 * Sets the payoffId.
		 * @param payoffId  the new value, not empty
		 * @return this, for chaining, not null
		 */
		public Builder payoffId(String payoffId) {
			JodaBeanUtils.notEmpty(payoffId, "payoffId");
			this.payoffId = payoffId;
			return this;
		}

		/**
		 * Sets the asianOption.
		 * @param asianOption  the new value
		 * @return this, for chaining, not null
		 */
		public Builder asianOption(AsianOption asianOption) {
			this.asianOption = asianOption;
			return this;
		}

		/**
		 * Sets the vanillaOption.
		 * @param vanillaOption  the new value
		 * @return this, for chaining, not null
		 */
		public Builder vanillaOption(VanillaOption vanillaOption) {
			this.vanillaOption = vanillaOption;
			return this;
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(224);
			buf.append("Derivative.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("underlying").append('=').append(JodaBeanUtils.toString(underlying)).append(',').append(' ');
			buf.append("issueDate").append('=').append(JodaBeanUtils.toString(issueDate)).append(',').append(' ');
			buf.append("expiryDate").append('=').append(JodaBeanUtils.toString(expiryDate)).append(',').append(' ');
			buf.append("payoffId").append('=').append(JodaBeanUtils.toString(payoffId)).append(',').append(' ');
			buf.append("asianOption").append('=').append(JodaBeanUtils.toString(asianOption)).append(',').append(' ');
			buf.append("vanillaOption").append('=').append(JodaBeanUtils.toString(vanillaOption)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
